% Funzione che definisce accelerazioni (accTL), dati magnetici (magTL), 
% temperature (tempTL) per i nodi di tipo Tilt Link

function [TimeTL,accTL,magTL,tempTL,ErrTiltLink] = defDatiTL(DatiTiltLink,...
    ErrTiltLink,Ndatidespike,rTL,MEMS,conn,catena,IDcentralina,DTcatena,Unit,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'defDatiTL function started';
fprintf(fileID,fmt,text);

[r,c] = size(DatiTiltLink);
Ncorr = 0;
% Elimino gli eventuali Not a Number
for a = 2:r
    for b = 1:c
        check = isnan(DatiTiltLink(a,b));
        if check == 1
            DatiTiltLink(a,b) = DatiTiltLink(a-1,b);
            ErrTiltLink(a,b-1) = 1;
            Ncorr = Ncorr+1;
        end
    end
end

text = [num2str(Ncorr) ' NaN of Tilt Link V corrected by defDatiTL function'];
fprintf(fileID,fmt,text);

% Definisco Data (gg:mm:aaaa hh:mm), Batteria, i 3 dati di accelerometro
% e magnetometro e la Temperatura per la calibrazione
TimeTL = DatiTiltLink(:,1); % data
accTL = zeros(r,rTL*3); % dati accelerometro
magTL = zeros(r,rTL*3); % dati magnetometro
tempTL = zeros(r,rTL); % temperatura del nodo per la calibrazione
p = 7; % passo nella definizione dei dati

% NOTA: Si esegue l'inversione delle colonne N°9 e N°8 per considerare 
% l'errore in lettura sulle centraline, ovvero lo scambio degli assi 
% y e z del magnetometro.
s = 1;
m = 1;

if MEMS == 1 % inverto le colonne Y e Z del magnetometro (MEMS vecchi, PRE 21 Maggio 2016)
    for i = 1:rTL
        accTL(:,s) = DatiTiltLink(:,2+(i-1)*p);
        accTL(:,s+1) = DatiTiltLink(:,3+(i-1)*p);
        accTL(:,s+2) = DatiTiltLink(:,4+(i-1)*p);    
        s = s+3;
        magTL(:,m) = DatiTiltLink(:,5+(i-1)*p);
        magTL(:,m+1) = DatiTiltLink(:,7+(i-1)*p);
        magTL(:,m+2) = DatiTiltLink(:,6+(i-1)*p);
        m = m+3;
        tempTL(:,i) = DatiTiltLink(:,8+(i-1)*p);
    end
elseif MEMS == 2 % Nodi nuovi, dopo 21 Maggio 2016
    for i = 1:rTL
        accTL(:,s) = DatiTiltLink(:,2+(i-1)*p);
        accTL(:,s+1) = DatiTiltLink(:,3+(i-1)*p);
        accTL(:,s+2) = DatiTiltLink(:,4+(i-1)*p);    
        s = s+3;
        magTL(:,m) = DatiTiltLink(:,5+(i-1)*p);
        magTL(:,m+1) = DatiTiltLink(:,6+(i-1)*p);
        magTL(:,m+2) = DatiTiltLink(:,7+(i-1)*p);
        m = m+3;
        tempTL(:,i) = DatiTiltLink(:,8+(i-1)*p);
        [rT,~] = size(tempTL);
        for j = 1:rT
            if tempTL(j,i) > 200
               tempTL(j,i) = tempTL(j,i) - 256; % Correzione della temperatura dei nuovi MEMS
            end
        end
    end
elseif MEMS == 3 % Nodi nuovi, dopo 21 Maggio 2016
    for i = 1:rTL
        accTL(:,s) = DatiTiltLink(:,2+(i-1)*p);
        accTL(:,s+1) = DatiTiltLink(:,3+(i-1)*p);
        accTL(:,s+2) = DatiTiltLink(:,4+(i-1)*p);    
        s = s+3;
        magTL(:,m) = DatiTiltLink(:,5+(i-1)*p);
        magTL(:,m+1) = DatiTiltLink(:,6+(i-1)*p);
        magTL(:,m+2) = DatiTiltLink(:,7+(i-1)*p);
        m = m+3;
        tempTL(:,i) = DatiTiltLink(:,8+(i-1)*p);
    end
end

if strcmp(Unit,'G301') == 1
    i = 1;
    j = 1;
    while i <= 3*rTL
        for ii = 2:r
            if accTL(ii,i) == -8191 && accTL(ii,i+1) == 0 && accTL(ii,i+2) == 0
                accTL(ii,i) = accTL(ii-1,i);
                accTL(ii,i+1) = accTL(ii-1,i+1);
                accTL(ii,i+2) = accTL(ii-1,i+2);
                magTL(ii,i) = magTL(ii-1,i);
                magTL(ii,i+1) = magTL(ii-1,i+1);
                magTL(ii,i+2) = magTL(ii-1,i+2);
                tempTL(ii,j) = tempTL(ii-1,j);
                ErrTiltLink(ii,i) = 1;
            end
        end
        i = i+3;
        j = j+1;
    end
end

s = 1;
m = 1;
Num_Dati = Ndatidespike; % numero di dati per il despike
if Num_Dati > r
    Num_Dati = r;
end
for i = 1:rTL
    % despiking accelerometri
    accTL(:,s) = filloutliers(accTL(:,s),'linear','movmedian',Num_Dati);    
    accTL(:,s+1) = filloutliers(accTL(:,s+1),'linear','movmedian',Num_Dati);    
    accTL(:,s+2) = filloutliers(accTL(:,s+2),'linear','movmedian',Num_Dati);    
    s = s+3;
    % despiking magnetometri
    magTL(:,m) = filloutliers(magTL(:,m),'linear','movmedian',Num_Dati);    
    magTL(:,m+1) = filloutliers(magTL(:,m+1),'linear','movmedian',Num_Dati);    
    magTL(:,m+2) = filloutliers(magTL(:,m+2),'linear','movmedian',Num_Dati);  
    m = m+3;
end

%% Specifico DT0002
if strcmp(DTcatena,'DT0002')
    TL = 1;
    TRec = zeros(rTL,1);
    [rC,~] = size(catena);
    idNodo = cell2mat(catena(:,1));
    for a = 1:rC
        nNodo = mat2str(cell2mat(catena(a,3)));
        if idNodo(a,1) == 1 % Tilt Link V
            %% Importazione dei dati di calibrazione per Tilt Link V
            comando = ['select Cal9 from CalibrationView where UnitName = '''...
                IDcentralina ''' and ToolNameID = ''' DTcatena ''' and NodeNum = ''' nNodo ''''];
            curs = exec(conn,comando);
            curs = fetch(curs);
            TRec(TL,:) = cell2mat(curs.Data); % matrice che raccoglie i dati del nodo numero 'a' di tipo Tilt Link V
            TL = TL+1;
            ok = ['Temperature calibration coefficient of node Tilt Link V number ' nNodo ' chain DT0002 recovered correctly'];
            fprintf(fileID,fmt,ok);
        end
    end
    for ii=1:rTL
        tempTL(:,ii) = tempTL(:,ii)/128+TRec(ii);
    end
    accTL = accTL/16;
end

text = 'Data of Tilt Link V defined correctly. defDatiTL function ended';
fprintf(fileID,fmt,text);
fclose(fileID);

end
